library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.numeric_std.all;

entity FILL_LEVEL is
   generic(
      C_FL_WIDTH : integer := 132);
   port (
      ------------------  System Signals  ----------------------
      rst        : in std_logic;
      clk_100MHz : in std_logic;
      eclk_25MHz : in std_logic;
      
      ------------------  Control Signals  ----------------------
      ADD_i : in std_logic;
      SUB_i : in std_logic;
      
      ------------------  Outgoing Signals  ----------------------
      bram_fill_level_o : out std_logic_vector(C_FL_WIDTH-1 downto 0)
      );
   attribute keep_hierarchy : string;
   attribute keep_hierarchy of FILL_LEVEL : entity is "YES";
end FILL_LEVEL;

architecture Behavioral of FILL_LEVEL is

   signal bram_fill_level_r  : unsigned(C_FL_WIDTH-1 downto 0); -- clocked register
   signal bram_fill_level_nw : unsigned(C_FL_WIDTH-1 downto 0); -- next wire

   signal comb_s : std_logic_vector(1 downto 0);
   
   -- attribute keep : string;
   -- attribute keep of bram_fill_level_nw : signal is "true";

   -- attribute TIG : string;
   -- attribute TIG of bram_fill_level_nw : signal is "true";
   
begin

   


   -- -- ---------------------------------------------
   -- comb_s <= ADD_i & SUB_i;
   
   -- bram_fill_level_clk_proc : process(clk_100MHz)
   -- begin
      -- if rising_edge(clk_100MHz) then
         -- if (rst = '1') then
            -- bram_fill_level_r <= to_unsigned(0,C_FL_WIDTH);
         -- elsif (eclk_25MHz = '1') then
            -- case comb_s is
            -- when "10" =>
               -- bram_fill_level_r <= bram_fill_level_r + 1;
            -- when "01" =>
               -- bram_fill_level_r <= bram_fill_level_r - 1;
            -- when others =>
               -- NULL;
            -- end case;
         -- end if;
      -- end if;
   -- end process;
   
   -- ---------------------------------------------
   bram_fill_level_clk_proc : process(clk_100MHz)
   begin
      if rising_edge(clk_100MHz) then
         if (rst = '1') then
            bram_fill_level_r <= to_unsigned(0,C_FL_WIDTH);
         elsif (eclk_25MHz = '1') then
            bram_fill_level_r <= bram_fill_level_nw;
         end if;
      end if;
   end process;

   -- -- ---------------------------------------------
   -- bram_fill_level_comb_proc : process(comb_s, bram_fill_level_r)
   -- begin
      -- case comb_s is
      -- when "10" =>
         -- bram_fill_level_nw <= bram_fill_level_r + 1;
      -- when "01" =>
         -- bram_fill_level_nw <= bram_fill_level_r - 1;
      -- when others =>
         -- bram_fill_level_nw <= bram_fill_level_r;
      -- end case;
   -- end process;
      
   -- ---------------------------------------------
   bram_fill_level_comb_proc : process(ADD_i, SUB_i, bram_fill_level_r)
   begin
      bram_fill_level_nw <= bram_fill_level_r;
      if (ADD_i = '1' and SUB_i = '1') then
         bram_fill_level_nw <= bram_fill_level_r;
      elsif (ADD_i = '1') then
         bram_fill_level_nw <= bram_fill_level_r + 1;
      elsif (SUB_i = '1') then
         bram_fill_level_nw <= bram_fill_level_r - 1;
      end if;
   end process;
   
   -- ---------------------------------------------
   bram_fill_level_o <= std_logic_vector(bram_fill_level_r);

end Behavioral;